//*****************************************************************
// 
//  JAVA Source for com.idautomation.qrcode; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.qrcode;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
/** This is the QRCode servlet that creates a barcode from the QRCode class. */
public class IDAutomationServlet extends HttpServlet 
{
    /**
    * Handle the HTTP POST method by sending an e-mail
    */
    private boolean debug=false;
    public void init() throws ServletException  {	}
    // MODIFY THIS METHOD TO RETRIEVE DATA TO ENCODE, CREATE THE QRCode AND SET THE PARAMETERS
    private QRCode getChart (HttpServletRequest request) 
    {
        QRCode cb=new QRCode();
        if (request!=null) 
        {
            // Remark these parameters out if you do not need them. We also recommend fixing parameters so they
            // do not need to be defined in the QRCode IMG string. For example, instead of 
            // if (request.getParameter("BAR_HEIGHT")!=null) cb.barHeightCM=new Double(request.getParameter("BAR_HEIGHT")).doubleValue();
            // use
            // cb.barHeightCM=2;
            // if you always use a bar height of 2.
            String st = null;

            if (request.getParameter("MODE")!=null)
            {
                st = (request.getParameter("MODE"));
                if (st.toUpperCase().compareTo("B") == 0 || st.toUpperCase().compareTo("0") == 0)			
                    cb.encodingMode = "Byte";
                if (st.toUpperCase().compareTo("N") == 0 || st.toUpperCase().compareTo("1") == 0)			
                    cb.encodingMode = "Numeric";
                if (st.toUpperCase().compareTo("A") == 0 || st.toUpperCase().compareTo("2") == 0)			
                    cb.encodingMode = "Alpha";
            }
            if (request.getParameter("ECL")!=null)
            {
                
                String ECLParam = request.getParameter("ECL");                
                if(ECLParam.toUpperCase().compareTo("L")==0)
                {
                    cb.setErrorCorrectionLevel("L");
                }
                if(ECLParam.toUpperCase().compareTo("H")==0)
                {
                    cb.setErrorCorrectionLevel("H");
                }
                if(ECLParam.toUpperCase().compareTo("Q")==0)
                {
                    cb.setErrorCorrectionLevel("Q");
                }
                if(ECLParam.toUpperCase().compareTo("M")==0)
                {
                    cb.setErrorCorrectionLevel("M");
                }
            }
            if (request.getParameter("V")!=null)
            {
                int Ver = (int) new Integer(request.getParameter("V")).intValue();
                if(Ver >= 1 && Ver <= 40)
                    cb.setVersion(Ver);
                else
                    cb.setVersion(0);
            }
            if (request.getParameter("O")!=null) cb.rotate=new Integer(request.getParameter("O")).intValue();
            if (request.getParameter("X")!=null) cb.X=new Double(request.getParameter("X")).doubleValue();
            if (request.getParameter("LM")!=null) cb.leftMarginCM=new Double(request.getParameter("LM")).doubleValue();
            if (request.getParameter("TM")!=null) cb.topMarginCM=new Double(request.getParameter("TM")).doubleValue();
            if (request.getParameter("BC")!=null) cb.barColor=convertColor(request.getParameter("BC"));
            if (request.getParameter("BGC")!=null) cb.backColor=convertColor(request.getParameter("BGC"));
            if (request.getParameter("IR")!=null) cb.setPixelsPerCM(new Integer(request.getParameter("IR")).intValue());
            if (request.getParameter("PT")!=null)
            {
                String STParameter = request.getParameter("PT");
                if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                   STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                   cb.applyTilde = true;
                else
                   cb.applyTilde = false;
            }
            if(request.getParameter("D")!=null)
            {
                cb.code=request.getParameter("D");
            }
        }
        return cb;
    }
    private String[] convertList(String items)
    {
            String[] itema=new String[500];
            int itemCount=0;
            // count number of items
            int p=items.indexOf("|");
            while (p>=0) 
            {
                    itema[itemCount++]=items.substring(0,p);
                    items=items.substring(p+1,items.length());
                    p=items.indexOf("|");
            }
            if (items.compareTo("")!=0) itema[itemCount++]=items;
            if (itemCount==0) return null;
            String[] result=new String[itemCount];
            for (int i=0;i<itemCount;i++) result[i]=itema[i];
            return result;
    }
    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e)
        {
            return java.awt.Color.black;
        }
    }

    // Handle the request
    // 1. create QRCode
    // 2. draw QRCode in a Buffered Image
    // 3. encode image as GIF or JPEG and send it to the browser
    public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
    {
        PrintWriter	out;
        ServletOutputStream outb;
        //default encoding type
        String encode="gif";
        if (request!=null) 
        {
                if (request.getParameter("I")!=null)  encode=request.getParameter("I").toLowerCase();
                if (encode.compareTo("gif")!=0) encode="jpeg";
        }
        response.setContentType("image/"+encode);
        outb=response.getOutputStream();
        // avoid caching in browser
        response.setHeader ("Pragma", "no-cache");
        response.setHeader ("Cache-Control", "no-cache");
        response.setDateHeader ("Expires",0);
        try 
        { 
            // find sizes
            int w=10;
            int h=10;
            // get the QRCode
            QRCode cb=getChart(request);
            if ((request!=null) && (request.getParameter("W")!=null) && (request.getParameter("H")!=null)) 
            {
                w=new Integer(request.getParameter("W")).intValue();
                h=new Integer(request.getParameter("H")).intValue();
            }
            else 
            {
                //a temp image must be created to find the preferred size
                cb.autoSize=true;
                cb.setSize(600,90);
                java.awt.image.BufferedImage imageTemp = new java.awt.image.BufferedImage( cb.getSize().width,cb.getSize().height,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
                java.awt.Graphics imgTempGraphics = imageTemp.createGraphics();
                cb.paint(imgTempGraphics);
                cb.invalidate();
                w=cb.getSize().width;
                h=cb.getSize().height;
                imgTempGraphics.dispose();
            }
            java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
            java.awt.Graphics2D BarGraphics=BarImage.createGraphics();
            if (debug) System.out.println("Size: "+w+" "+h);
            cb.setSize(w,h);
            cb.paint(BarGraphics);
            if (encode.compareToIgnoreCase("gif")==0) 
            {
                // encode buffered image to a gif
                com.idautomation.qrcode.encoder.GifEncoder encoder = new com.idautomation.qrcode.encoder.GifEncoder(BarImage  ,outb);
                encoder.encode();
            }
            else
            {
                // create JPEG image
                com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
                //increase the JPEG quality to 100%
                com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( BarImage); 
                param.setQuality(1.0F,true);
                encoder.setJPEGEncodeParam(param);
                encoder.encode( BarImage,param  );
            }
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }

    public void doPost (HttpServletRequest request, HttpServletResponse response)						throws ServletException
    {
        try 
        {
            doGet(request,response);
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }
}
